<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<!-- NewPage -->
<html lang="en">
<head>
<!-- Generated by javadoc (version 1.7.0_80) on Wed Sep 20 14:52:14 UTC 2017 -->
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<title>ResolutionStrategy (Gradle API 4.2)</title>
<meta name="date" content="2017-09-20">
<link rel="stylesheet" type="text/css" href="../../../../javadoc.css" title="Style">
</head>
<body>
<script type="text/javascript"><!--
    if (location.href.indexOf('is-external=true') == -1) {
        parent.document.title="ResolutionStrategy (Gradle API 4.2)";
    }
//-->
</script>
<noscript>
<div>JavaScript is disabled on your browser.</div>
</noscript>
<!-- ========= START OF TOP NAVBAR ======= -->
<div class="topNav"><a name="navbar_top">
<!--   -->
</a><a href="#skip-navbar_top" title="Skip navigation links"></a><a name="navbar_top_firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../../overview-summary.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../../index-all.html">Index</a></li>
<li><a href="../../../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li><a href="../../../../org/gradle/api/artifacts/PublishException.html" title="class in org.gradle.api.artifacts"><span class="strong">Prev Class</span></a></li>
<li><a href="../../../../org/gradle/api/artifacts/ResolutionStrategy.SortOrder.html" title="enum in org.gradle.api.artifacts"><span class="strong">Next Class</span></a></li>
</ul>
<ul class="navList">
<li><a href="../../../../index.html?org/gradle/api/artifacts/ResolutionStrategy.html" target="_top">Frames</a></li>
<li><a href="ResolutionStrategy.html" target="_top">No Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_top">
<li><a href="../../../../allclasses-noframe.html">All Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_top");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li><a href="#nested_class_summary">Nested</a>&nbsp;|&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li>Constr&nbsp;|&nbsp;</li>
<li><a href="#method_summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li>Constr&nbsp;|&nbsp;</li>
<li><a href="#method_detail">Method</a></li>
</ul>
</div>
<a name="skip-navbar_top">
<!--   -->
</a></div>
<!-- ========= END OF TOP NAVBAR ========= -->
<!-- ======== START OF CLASS DATA ======== -->
<div class="header">
<div class="subTitle">org.gradle.api.artifacts</div>
<h2 title="Interface ResolutionStrategy" class="title">Interface ResolutionStrategy</h2>
</div>
<div class="contentContainer">
<div class="description">
<ul class="blockList">
<li class="blockList">
<hr>
<br>
<pre>public interface <span class="strong">ResolutionStrategy</span></pre>
<div class="block">Defines the strategies around dependency resolution.
 For example, forcing certain dependency versions, substitutions, conflict resolutions or snapshot timeouts.
 <p>
 Examples:
 <pre class='autoTested'>
 apply plugin: 'java' //so that there are some configurations

 configurations.all {
   resolutionStrategy {
     // fail eagerly on version conflict (includes transitive dependencies)
     // e.g. multiple different versions of the same dependency (group and name are equal)
     failOnVersionConflict()

     // prefer modules that are part of this build (multi-project or composite build) over external modules
     preferProjectModules()

     // force certain versions of dependencies (including transitive)
     //  *append new forced modules:
     force 'asm:asm-all:3.3.1', 'commons-io:commons-io:1.4'
     //  *replace existing forced modules with new ones:
     forcedModules = ['asm:asm-all:3.3.1']

     // add dependency substitution rules
     dependencySubstitution {
       substitute module('org.gradle:api') with project(':api')
       substitute project(':util') with module('org.gradle:util:3.0')
     }

     // cache dynamic versions for 10 minutes
     cacheDynamicVersionsFor 10*60, 'seconds'
     // don't cache changing modules at all
     cacheChangingModulesFor 0, 'seconds'
   }
 }
 </pre></div>
<dl><dt><span class="strong">Since:</span></dt>
  <dd>1.0-milestone-6</dd></dl>
</li>
</ul>
</div>
<div class="summary">
<ul class="blockList">
<li class="blockList">
<!-- ======== NESTED CLASS SUMMARY ======== -->
<ul class="blockList">
<li class="blockList"><a name="nested_class_summary">
<!--   -->
</a>
<h3>Nested Class Summary</h3>
<table class="overviewSummary" border="0" cellpadding="3" cellspacing="0" summary="Nested Class Summary table, listing nested classes, and an explanation">
<caption><span>Nested Classes</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colLast" scope="col">Interface and Description</th>
</tr>
<tr class="altColor">
<td class="colFirst"><code>static class&nbsp;</code></td>
<td class="colLast"><code><strong><a href="../../../../org/gradle/api/artifacts/ResolutionStrategy.SortOrder.html" title="enum in org.gradle.api.artifacts">ResolutionStrategy.SortOrder</a></strong></code>
<div class="block">Defines the sort order for components and artifacts produced by the configuration.</div>
</td>
</tr>
</table>
</li>
</ul>
<!-- ========== METHOD SUMMARY =========== -->
<ul class="blockList">
<li class="blockList"><a name="method_summary">
<!--   -->
</a>
<h3>Method Summary</h3>
<table class="overviewSummary" border="0" cellpadding="3" cellspacing="0" summary="Method Summary table, listing methods, and an explanation">
<caption><span>Methods</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colLast" scope="col">Method and Description</th>
</tr>
<tr class="altColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><strong><a href="../../../../org/gradle/api/artifacts/ResolutionStrategy.html#cacheChangingModulesFor(int,%20java.lang.String)">cacheChangingModulesFor</a></strong>(int&nbsp;value,
                       <a href="https://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&nbsp;units)</code>
<div class="block">Sets the length of time that changing modules will be cached, with units expressed as a String.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><strong><a href="../../../../org/gradle/api/artifacts/ResolutionStrategy.html#cacheChangingModulesFor(int,%20java.util.concurrent.TimeUnit)">cacheChangingModulesFor</a></strong>(int&nbsp;value,
                       <a href="https://docs.oracle.com/javase/7/docs/api/java/util/concurrent/TimeUnit.html?is-external=true" title="class or interface in java.util.concurrent">TimeUnit</a>&nbsp;units)</code>
<div class="block">Sets the length of time that changing modules will be cached.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><strong><a href="../../../../org/gradle/api/artifacts/ResolutionStrategy.html#cacheDynamicVersionsFor(int,%20java.lang.String)">cacheDynamicVersionsFor</a></strong>(int&nbsp;value,
                       <a href="https://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&nbsp;units)</code>
<div class="block">Sets the length of time that dynamic versions will be cached, with units expressed as a String.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><strong><a href="../../../../org/gradle/api/artifacts/ResolutionStrategy.html#cacheDynamicVersionsFor(int,%20java.util.concurrent.TimeUnit)">cacheDynamicVersionsFor</a></strong>(int&nbsp;value,
                       <a href="https://docs.oracle.com/javase/7/docs/api/java/util/concurrent/TimeUnit.html?is-external=true" title="class or interface in java.util.concurrent">TimeUnit</a>&nbsp;units)</code>
<div class="block">Sets the length of time that dynamic versions will be cached.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code><a href="../../../../org/gradle/api/artifacts/ResolutionStrategy.html" title="interface in org.gradle.api.artifacts">ResolutionStrategy</a></code></td>
<td class="colLast"><code><strong><a href="../../../../org/gradle/api/artifacts/ResolutionStrategy.html#componentSelection(org.gradle.api.Action)">componentSelection</a></strong>(<a href="../../../../org/gradle/api/Action.html" title="interface in org.gradle.api">Action</a>&lt;? super <a href="../../../../org/gradle/api/artifacts/ComponentSelectionRules.html" title="interface in org.gradle.api.artifacts">ComponentSelectionRules</a>&gt;&nbsp;action)</code>
<div class="block">The componentSelection block provides rules to filter or blacklist certain components from appearing in the resolution result.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code><a href="../../../../org/gradle/api/artifacts/ResolutionStrategy.html" title="interface in org.gradle.api.artifacts">ResolutionStrategy</a></code></td>
<td class="colLast"><code><strong><a href="../../../../org/gradle/api/artifacts/ResolutionStrategy.html#dependencySubstitution(org.gradle.api.Action)">dependencySubstitution</a></strong>(<a href="../../../../org/gradle/api/Action.html" title="interface in org.gradle.api">Action</a>&lt;? super <a href="../../../../org/gradle/api/artifacts/DependencySubstitutions.html" title="interface in org.gradle.api.artifacts">DependencySubstitutions</a>&gt;&nbsp;action)</code>
<div class="block">Configures the set of dependency substitution rules for this configuration.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code><a href="../../../../org/gradle/api/artifacts/ResolutionStrategy.html" title="interface in org.gradle.api.artifacts">ResolutionStrategy</a></code></td>
<td class="colLast"><code><strong><a href="../../../../org/gradle/api/artifacts/ResolutionStrategy.html#eachDependency(org.gradle.api.Action)">eachDependency</a></strong>(<a href="../../../../org/gradle/api/Action.html" title="interface in org.gradle.api">Action</a>&lt;? super <a href="../../../../org/gradle/api/artifacts/DependencyResolveDetails.html" title="interface in org.gradle.api.artifacts">DependencyResolveDetails</a>&gt;&nbsp;rule)</code>
<div class="block">Adds a dependency substitution rule that is triggered for every dependency (including transitive)
 when the configuration is being resolved.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code><a href="../../../../org/gradle/api/artifacts/ResolutionStrategy.html" title="interface in org.gradle.api.artifacts">ResolutionStrategy</a></code></td>
<td class="colLast"><code><strong><a href="../../../../org/gradle/api/artifacts/ResolutionStrategy.html#failOnVersionConflict()">failOnVersionConflict</a></strong>()</code>
<div class="block">In case of conflict, Gradle by default uses the newest of conflicting versions.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code><a href="../../../../org/gradle/api/artifacts/ResolutionStrategy.html" title="interface in org.gradle.api.artifacts">ResolutionStrategy</a></code></td>
<td class="colLast"><code><strong><a href="../../../../org/gradle/api/artifacts/ResolutionStrategy.html#force(java.lang.Object...)">force</a></strong>(<a href="https://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true" title="class or interface in java.lang">Object</a>...&nbsp;moduleVersionSelectorNotations)</code>
<div class="block">Allows forcing certain versions of dependencies, including transitive dependencies.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code><a href="../../../../org/gradle/api/artifacts/ComponentSelectionRules.html" title="interface in org.gradle.api.artifacts">ComponentSelectionRules</a></code></td>
<td class="colLast"><code><strong><a href="../../../../org/gradle/api/artifacts/ResolutionStrategy.html#getComponentSelection()">getComponentSelection</a></strong>()</code>
<div class="block">Returns the currently configured version selection rules object.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code><a href="../../../../org/gradle/api/artifacts/DependencySubstitutions.html" title="interface in org.gradle.api.artifacts">DependencySubstitutions</a></code></td>
<td class="colLast"><code><strong><a href="../../../../org/gradle/api/artifacts/ResolutionStrategy.html#getDependencySubstitution()">getDependencySubstitution</a></strong>()</code>
<div class="block">Returns the set of dependency substitution rules that are set for this configuration.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code><a href="https://docs.oracle.com/javase/7/docs/api/java/util/Set.html?is-external=true" title="class or interface in java.util">Set</a>&lt;<a href="../../../../org/gradle/api/artifacts/ModuleVersionSelector.html" title="interface in org.gradle.api.artifacts">ModuleVersionSelector</a>&gt;</code></td>
<td class="colLast"><code><strong><a href="../../../../org/gradle/api/artifacts/ResolutionStrategy.html#getForcedModules()">getForcedModules</a></strong>()</code>
<div class="block">Returns currently configured forced modules.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><strong><a href="../../../../org/gradle/api/artifacts/ResolutionStrategy.html#preferProjectModules()">preferProjectModules</a></strong>()</code>
<div class="block">Gradle can resolve conflicts purely by version number or prioritize project dependencies over binary.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code><a href="../../../../org/gradle/api/artifacts/ResolutionStrategy.html" title="interface in org.gradle.api.artifacts">ResolutionStrategy</a></code></td>
<td class="colLast"><code><strong><a href="../../../../org/gradle/api/artifacts/ResolutionStrategy.html#setForcedModules(java.lang.Object...)">setForcedModules</a></strong>(<a href="https://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true" title="class or interface in java.lang">Object</a>...&nbsp;moduleVersionSelectorNotations)</code>
<div class="block">Allows forcing certain versions of dependencies, including transitive dependencies.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><strong><a href="../../../../org/gradle/api/artifacts/ResolutionStrategy.html#sortArtifacts(org.gradle.api.artifacts.ResolutionStrategy.SortOrder)">sortArtifacts</a></strong>(<a href="../../../../org/gradle/api/artifacts/ResolutionStrategy.SortOrder.html" title="enum in org.gradle.api.artifacts">ResolutionStrategy.SortOrder</a>&nbsp;sortOrder)</code>
<div class="block">Specifies the ordering for resolved artifacts.</div>
</td>
</tr>
</table>
</li>
</ul>
</li>
</ul>
</div>
<div class="details">
<ul class="blockList">
<li class="blockList">
<!-- ============ METHOD DETAIL ========== -->
<ul class="blockList">
<li class="blockList"><a name="method_detail">
<!--   -->
</a>
<h3>Method Detail</h3>
<a name="failOnVersionConflict()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>failOnVersionConflict</h4>
<pre><a href="../../../../org/gradle/api/artifacts/ResolutionStrategy.html" title="interface in org.gradle.api.artifacts">ResolutionStrategy</a>&nbsp;failOnVersionConflict()</pre>
<div class="block">In case of conflict, Gradle by default uses the newest of conflicting versions.
 However, you can change this behavior. Use this method to configure the resolution to fail eagerly on any version conflict, e.g.
 multiple different versions of the same dependency (group and name are equal) in the same <a href="../../../../org/gradle/api/artifacts/Configuration.html" title="interface in org.gradle.api.artifacts"><code>Configuration</code></a>.
 The check includes both first level and transitive dependencies. See example below:

 <pre class='autoTested'>
 apply plugin: 'java' //so that there are some configurations

 configurations.all {
   resolutionStrategy.failOnVersionConflict()
 }
 </pre></div>
<dl><dt><span class="strong">Returns:</span></dt><dd>this resolution strategy instance</dd><dt><span class="strong">Since:</span></dt>
  <dd>1.0-milestone-6</dd></dl>
</li>
</ul>
<a name="preferProjectModules()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>preferProjectModules</h4>
<pre><a href="../../../../org/gradle/api/Incubating.html" title="annotation in org.gradle.api">@Incubating</a>
void&nbsp;preferProjectModules()</pre>
<div class="block">Gradle can resolve conflicts purely by version number or prioritize project dependencies over binary.
 The default is <b>by version number</b>.<p>
 This applies to both first level and transitive dependencies. See example below:

 <pre class='autoTested'>
 apply plugin: 'java' //so that there are some configurations

 configurations.all {
   resolutionStrategy.preferProjectModules()
 }
 </pre></div>
<dl><dt><span class="strong">Since:</span></dt>
  <dd>3.2</dd></dl>
</li>
</ul>
<a name="force(java.lang.Object...)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>force</h4>
<pre><a href="../../../../org/gradle/api/artifacts/ResolutionStrategy.html" title="interface in org.gradle.api.artifacts">ResolutionStrategy</a>&nbsp;force(<a href="https://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true" title="class or interface in java.lang">Object</a>...&nbsp;moduleVersionSelectorNotations)</pre>
<div class="block">Allows forcing certain versions of dependencies, including transitive dependencies.
 <b>Appends</b> new forced modules to be considered when resolving dependencies.
 <p>
 It accepts following notations:
 <ul>
   <li>String in a format of: 'group:name:version', for example: 'org.gradle:gradle-core:1.0'</li>
   <li>instance of <a href="../../../../org/gradle/api/artifacts/ModuleVersionSelector.html" title="interface in org.gradle.api.artifacts"><code>ModuleVersionSelector</code></a></li>
   <li>any collection or array of above will be automatically flattened</li>
 </ul>
 Example:
 <pre class='autoTested'>
 apply plugin: 'java' //so that there are some configurations

 configurations.all {
   resolutionStrategy.force 'asm:asm-all:3.3.1', 'commons-io:commons-io:1.4'
 }
 </pre></div>
<dl><dt><span class="strong">Parameters:</span></dt><dd><code>moduleVersionSelectorNotations</code> - typically group:name:version notations to append</dd>
<dt><span class="strong">Returns:</span></dt><dd>this ResolutionStrategy instance</dd><dt><span class="strong">Since:</span></dt>
  <dd>1.0-milestone-7</dd></dl>
</li>
</ul>
<a name="setForcedModules(java.lang.Object...)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>setForcedModules</h4>
<pre><a href="../../../../org/gradle/api/artifacts/ResolutionStrategy.html" title="interface in org.gradle.api.artifacts">ResolutionStrategy</a>&nbsp;setForcedModules(<a href="https://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true" title="class or interface in java.lang">Object</a>...&nbsp;moduleVersionSelectorNotations)</pre>
<div class="block">Allows forcing certain versions of dependencies, including transitive dependencies.
 <b>Replaces</b> existing forced modules with the input.
 <p>
 For information on notations see <a href="../../../../org/gradle/api/artifacts/ResolutionStrategy.html#force(java.lang.Object...)"><code>force(Object...)</code></a>
 <p>
 Example:
 <pre class='autoTested'>
 apply plugin: 'java' //so that there are some configurations

 configurations.all {
   resolutionStrategy.forcedModules = ['asm:asm-all:3.3.1', 'commons-io:commons-io:1.4']
 }
 </pre></div>
<dl><dt><span class="strong">Parameters:</span></dt><dd><code>moduleVersionSelectorNotations</code> - typically group:name:version notations to set</dd>
<dt><span class="strong">Returns:</span></dt><dd>this ResolutionStrategy instance</dd><dt><span class="strong">Since:</span></dt>
  <dd>1.0-milestone-7</dd></dl>
</li>
</ul>
<a name="getForcedModules()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getForcedModules</h4>
<pre><a href="https://docs.oracle.com/javase/7/docs/api/java/util/Set.html?is-external=true" title="class or interface in java.util">Set</a>&lt;<a href="../../../../org/gradle/api/artifacts/ModuleVersionSelector.html" title="interface in org.gradle.api.artifacts">ModuleVersionSelector</a>&gt;&nbsp;getForcedModules()</pre>
<div class="block">Returns currently configured forced modules. For more information on forcing versions see <a href="../../../../org/gradle/api/artifacts/ResolutionStrategy.html#force(java.lang.Object...)"><code>force(Object...)</code></a></div>
<dl><dt><span class="strong">Returns:</span></dt><dd>forced modules</dd><dt><span class="strong">Since:</span></dt>
  <dd>1.0-milestone-7</dd></dl>
</li>
</ul>
<a name="eachDependency(org.gradle.api.Action)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>eachDependency</h4>
<pre><a href="../../../../org/gradle/api/Incubating.html" title="annotation in org.gradle.api">@Incubating</a>
<a href="../../../../org/gradle/api/artifacts/ResolutionStrategy.html" title="interface in org.gradle.api.artifacts">ResolutionStrategy</a>&nbsp;eachDependency(<a href="../../../../org/gradle/api/Action.html" title="interface in org.gradle.api">Action</a>&lt;? super <a href="../../../../org/gradle/api/artifacts/DependencyResolveDetails.html" title="interface in org.gradle.api.artifacts">DependencyResolveDetails</a>&gt;&nbsp;rule)</pre>
<div class="block">Adds a dependency substitution rule that is triggered for every dependency (including transitive)
 when the configuration is being resolved. The action receives an instance of <a href="../../../../org/gradle/api/artifacts/DependencyResolveDetails.html" title="interface in org.gradle.api.artifacts"><code>DependencyResolveDetails</code></a>
 that can be used to find out what dependency is being resolved and to influence the resolution process.
 Example:
 <pre class='autoTested'>
 configurations {
   compile.resolutionStrategy {
     eachDependency { DependencyResolveDetails details -&gt;
       //specifying a fixed version for all libraries with 'org.gradle' group
       if (details.requested.group == 'org.gradle') {
         details.useVersion '1.4'
       }
     }
     eachDependency { details -&gt;
       //multiple actions can be specified
       if (details.requested.name == 'groovy-all') {
          //changing the name:
          details.useTarget group: details.requested.group, name: 'groovy', version: details.requested.version
       }
     }
   }
 }
 </pre>

 The rules are evaluated in order they are declared. Rules are evaluated after forced modules are applied (see <a href="../../../../org/gradle/api/artifacts/ResolutionStrategy.html#force(java.lang.Object...)"><code>force(Object...)</code></a></div>
<dl><dt><span class="strong">Returns:</span></dt><dd>this</dd><dt><span class="strong">Since:</span></dt>
  <dd>1.4</dd></dl>
</li>
</ul>
<a name="cacheDynamicVersionsFor(int, java.lang.String)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>cacheDynamicVersionsFor</h4>
<pre>void&nbsp;cacheDynamicVersionsFor(int&nbsp;value,
                           <a href="https://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&nbsp;units)</pre>
<div class="block">Sets the length of time that dynamic versions will be cached, with units expressed as a String.

 <p>A convenience method for <a href="../../../../org/gradle/api/artifacts/ResolutionStrategy.html#cacheDynamicVersionsFor(int,%20java.util.concurrent.TimeUnit)"><code>cacheDynamicVersionsFor(int, java.util.concurrent.TimeUnit)</code></a> with units expressed as a String.
 Units are resolved by calling the <code>valueOf(String)</code> method of <a href="https://docs.oracle.com/javase/7/docs/api/java/util/concurrent/TimeUnit.html?is-external=true" title="class or interface in java.util.concurrent"><code>TimeUnit</code></a> with the upper-cased string value.</p></div>
<dl><dt><span class="strong">Parameters:</span></dt><dd><code>value</code> - The number of time units</dd><dd><code>units</code> - The units</dd><dt><span class="strong">Since:</span></dt>
  <dd>1.0-milestone-6</dd></dl>
</li>
</ul>
<a name="cacheDynamicVersionsFor(int, java.util.concurrent.TimeUnit)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>cacheDynamicVersionsFor</h4>
<pre>void&nbsp;cacheDynamicVersionsFor(int&nbsp;value,
                           <a href="https://docs.oracle.com/javase/7/docs/api/java/util/concurrent/TimeUnit.html?is-external=true" title="class or interface in java.util.concurrent">TimeUnit</a>&nbsp;units)</pre>
<div class="block">Sets the length of time that dynamic versions will be cached.

 <p>Gradle keeps a cache of dynamic version =&gt; resolved version (ie 2.+ =&gt; 2.3). By default, these cached values are kept for 24 hours, after which the cached entry is expired
 and the dynamic version is resolved again.</p>
 <p>Use this method to provide a custom expiry time after which the cached value for any dynamic version will be expired.</p></div>
<dl><dt><span class="strong">Parameters:</span></dt><dd><code>value</code> - The number of time units</dd><dd><code>units</code> - The units</dd><dt><span class="strong">Since:</span></dt>
  <dd>1.0-milestone-6</dd></dl>
</li>
</ul>
<a name="cacheChangingModulesFor(int, java.lang.String)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>cacheChangingModulesFor</h4>
<pre>void&nbsp;cacheChangingModulesFor(int&nbsp;value,
                           <a href="https://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&nbsp;units)</pre>
<div class="block">Sets the length of time that changing modules will be cached, with units expressed as a String.

 <p>A convenience method for <a href="../../../../org/gradle/api/artifacts/ResolutionStrategy.html#cacheChangingModulesFor(int,%20java.util.concurrent.TimeUnit)"><code>cacheChangingModulesFor(int, java.util.concurrent.TimeUnit)</code></a> with units expressed as a String.
 Units are resolved by calling the <code>valueOf(String)</code> method of <a href="https://docs.oracle.com/javase/7/docs/api/java/util/concurrent/TimeUnit.html?is-external=true" title="class or interface in java.util.concurrent"><code>TimeUnit</code></a> with the upper-cased string value.</p></div>
<dl><dt><span class="strong">Parameters:</span></dt><dd><code>value</code> - The number of time units</dd><dd><code>units</code> - The units</dd><dt><span class="strong">Since:</span></dt>
  <dd>1.0-milestone-6</dd></dl>
</li>
</ul>
<a name="cacheChangingModulesFor(int, java.util.concurrent.TimeUnit)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>cacheChangingModulesFor</h4>
<pre>void&nbsp;cacheChangingModulesFor(int&nbsp;value,
                           <a href="https://docs.oracle.com/javase/7/docs/api/java/util/concurrent/TimeUnit.html?is-external=true" title="class or interface in java.util.concurrent">TimeUnit</a>&nbsp;units)</pre>
<div class="block">Sets the length of time that changing modules will be cached.

 <p>Gradle caches the contents and artifacts of changing modules. By default, these cached values are kept for 24 hours,
 after which the cached entry is expired and the module is resolved again.</p>
 <p>Use this method to provide a custom expiry time after which the cached entries for any changing module will be expired.</p></div>
<dl><dt><span class="strong">Parameters:</span></dt><dd><code>value</code> - The number of time units</dd><dd><code>units</code> - The units</dd><dt><span class="strong">Since:</span></dt>
  <dd>1.0-milestone-6</dd></dl>
</li>
</ul>
<a name="getComponentSelection()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getComponentSelection</h4>
<pre><a href="../../../../org/gradle/api/Incubating.html" title="annotation in org.gradle.api">@Incubating</a>
<a href="../../../../org/gradle/api/artifacts/ComponentSelectionRules.html" title="interface in org.gradle.api.artifacts">ComponentSelectionRules</a>&nbsp;getComponentSelection()</pre>
<div class="block">Returns the currently configured version selection rules object.</div>
<dl><dt><span class="strong">Returns:</span></dt><dd>the version selection rules</dd><dt><span class="strong">Since:</span></dt>
  <dd>2.2</dd></dl>
</li>
</ul>
<a name="componentSelection(org.gradle.api.Action)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>componentSelection</h4>
<pre><a href="../../../../org/gradle/api/Incubating.html" title="annotation in org.gradle.api">@Incubating</a>
<a href="../../../../org/gradle/api/artifacts/ResolutionStrategy.html" title="interface in org.gradle.api.artifacts">ResolutionStrategy</a>&nbsp;componentSelection(<a href="../../../../org/gradle/api/Action.html" title="interface in org.gradle.api">Action</a>&lt;? super <a href="../../../../org/gradle/api/artifacts/ComponentSelectionRules.html" title="interface in org.gradle.api.artifacts">ComponentSelectionRules</a>&gt;&nbsp;action)</pre>
<div class="block">The componentSelection block provides rules to filter or blacklist certain components from appearing in the resolution result.</div>
<dl><dt><span class="strong">Parameters:</span></dt><dd><code>action</code> - Action to be applied to the <a href="../../../../org/gradle/api/artifacts/ComponentSelectionRules.html" title="interface in org.gradle.api.artifacts"><code>ComponentSelectionRules</code></a></dd>
<dt><span class="strong">Returns:</span></dt><dd>this ResolutionStrategy instance</dd><dt><span class="strong">Since:</span></dt>
  <dd>2.2</dd></dl>
</li>
</ul>
<a name="getDependencySubstitution()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getDependencySubstitution</h4>
<pre><a href="../../../../org/gradle/api/Incubating.html" title="annotation in org.gradle.api">@Incubating</a>
<a href="../../../../org/gradle/api/artifacts/DependencySubstitutions.html" title="interface in org.gradle.api.artifacts">DependencySubstitutions</a>&nbsp;getDependencySubstitution()</pre>
<div class="block">Returns the set of dependency substitution rules that are set for this configuration.</div>
<dl><dt><span class="strong">Since:</span></dt>
  <dd>2.5</dd></dl>
</li>
</ul>
<a name="dependencySubstitution(org.gradle.api.Action)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>dependencySubstitution</h4>
<pre><a href="../../../../org/gradle/api/Incubating.html" title="annotation in org.gradle.api">@Incubating</a>
<a href="../../../../org/gradle/api/artifacts/ResolutionStrategy.html" title="interface in org.gradle.api.artifacts">ResolutionStrategy</a>&nbsp;dependencySubstitution(<a href="../../../../org/gradle/api/Action.html" title="interface in org.gradle.api">Action</a>&lt;? super <a href="../../../../org/gradle/api/artifacts/DependencySubstitutions.html" title="interface in org.gradle.api.artifacts">DependencySubstitutions</a>&gt;&nbsp;action)</pre>
<div class="block">Configures the set of dependency substitution rules for this configuration.  The action receives an instance of <a href="../../../../org/gradle/api/artifacts/DependencySubstitutions.html" title="interface in org.gradle.api.artifacts"><code>DependencySubstitutions</code></a> which
 can then be configured with substitution rules.
 <p>Examples:</p>
 <pre class='autoTested'>
 // add dependency substitution rules
 configurations.all {
   resolutionStrategy.dependencySubstitution {
     // Substitute project and module dependencies
     substitute module('org.gradle:api') with project(':api')
     substitute project(':util') with module('org.gradle:util:3.0')

     // Substitute one module dependency for another
     substitute module('org.gradle:api:2.0') with module('org.gradle:api:2.1')
   }
 }
 </pre></div>
<dl><dt><span class="strong">Returns:</span></dt><dd>this ResolutionStrategy instance</dd><dt><span class="strong">Since:</span></dt>
  <dd>2.5</dd>
<dt><span class="strong">See Also:</span></dt><dd><a href="../../../../org/gradle/api/artifacts/DependencySubstitutions.html" title="interface in org.gradle.api.artifacts"><code>DependencySubstitutions</code></a></dd></dl>
</li>
</ul>
<a name="sortArtifacts(org.gradle.api.artifacts.ResolutionStrategy.SortOrder)">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>sortArtifacts</h4>
<pre><a href="../../../../org/gradle/api/Incubating.html" title="annotation in org.gradle.api">@Incubating</a>
void&nbsp;sortArtifacts(<a href="../../../../org/gradle/api/artifacts/ResolutionStrategy.SortOrder.html" title="enum in org.gradle.api.artifacts">ResolutionStrategy.SortOrder</a>&nbsp;sortOrder)</pre>
<div class="block">Specifies the ordering for resolved artifacts. Options are:
 <ul>
 <li><a href="../../../../org/gradle/api/artifacts/ResolutionStrategy.SortOrder.html#DEFAULT"><code>ResolutionStrategy.SortOrder.DEFAULT</code></a> : Don't specify the sort order. Gradle will provide artifacts in the default order.</li>
 <li><a href="../../../../org/gradle/api/artifacts/ResolutionStrategy.SortOrder.html#CONSUMER_FIRST"><code>ResolutionStrategy.SortOrder.CONSUMER_FIRST</code></a> : Artifacts for a consuming component should appear <em>before</em> artifacts for it's dependencies.</li>
 <li><a href="../../../../org/gradle/api/artifacts/ResolutionStrategy.SortOrder.html#DEPENDENCY_FIRST"><code>ResolutionStrategy.SortOrder.DEPENDENCY_FIRST</code></a> : Artifacts for a consuming component should appear <em>after</em> artifacts for it's dependencies.</li>
 </ul>
 A best attempt will be made to sort artifacts according the supplied <a href="../../../../org/gradle/api/artifacts/ResolutionStrategy.SortOrder.html" title="enum in org.gradle.api.artifacts"><code>ResolutionStrategy.SortOrder</code></a>, but no guarantees will be made in the presence of dependency cycles.

 NOTE: For a particular Gradle version, artifact ordering will be consistent. Multiple resolves for the same inputs will result in the
 same outputs in the same order.</div>
<dl><dt><span class="strong">Since:</span></dt>
  <dd>3.5</dd></dl>
</li>
</ul>
</li>
</ul>
</li>
</ul>
</div>
</div>
<!-- ========= END OF CLASS DATA ========= -->
<!-- ======= START OF BOTTOM NAVBAR ====== -->
<div class="bottomNav"><a name="navbar_bottom">
<!--   -->
</a><a href="#skip-navbar_bottom" title="Skip navigation links"></a><a name="navbar_bottom_firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../../overview-summary.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../../index-all.html">Index</a></li>
<li><a href="../../../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li><a href="../../../../org/gradle/api/artifacts/PublishException.html" title="class in org.gradle.api.artifacts"><span class="strong">Prev Class</span></a></li>
<li><a href="../../../../org/gradle/api/artifacts/ResolutionStrategy.SortOrder.html" title="enum in org.gradle.api.artifacts"><span class="strong">Next Class</span></a></li>
</ul>
<ul class="navList">
<li><a href="../../../../index.html?org/gradle/api/artifacts/ResolutionStrategy.html" target="_top">Frames</a></li>
<li><a href="ResolutionStrategy.html" target="_top">No Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_bottom">
<li><a href="../../../../allclasses-noframe.html">All Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_bottom");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li><a href="#nested_class_summary">Nested</a>&nbsp;|&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li>Constr&nbsp;|&nbsp;</li>
<li><a href="#method_summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li>Constr&nbsp;|&nbsp;</li>
<li><a href="#method_detail">Method</a></li>
</ul>
</div>
<a name="skip-navbar_bottom">
<!--   -->
</a></div>
<!-- ======== END OF BOTTOM NAVBAR ======= -->
</body>
</html>
